import React from "react";
export declare const mergeArrays: (template: TemplateStringsArray, templateElements: (string | undefined | null)[]) => (string | null | undefined)[];
export declare const cleanTemplate: (template: (string | undefined | null)[], inheritedClasses?: string) => string;
declare type TransientProps = Record<`$${string}`, any>;
export declare type TemplateFunction<P, E> = <K extends TransientProps = {}>(template: TemplateStringsArray, ...templateElements: ((props: P & K) => string | undefined | null)[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<P & K> & React.RefAttributes<E>>;
interface ClassNameProp {
    className?: string;
}
declare function templateFunction<P extends ClassNameProp, E = any>(Element: React.ComponentType<P>): TemplateFunction<P, E>;
export declare type IntrinsicElements = {
    [key in keyof JSX.IntrinsicElements]: TemplateFunction<JSX.IntrinsicElements[key], any>;
};
declare const tw: typeof templateFunction & IntrinsicElements;
export default tw;
